{{    This is PumpControl2WithPumpsREV2.spin
 The general idea here is to set up a system that actually turn pumps ON and OFF
 at specific times and durations over a typical 24hr day.

 I wanted something that is not confusing to edit in the future.
 While the Pump1 method is cumbersome, I think it will be easy enough to make
 changes to in the future.
 I have one IF statement for each hour during the day.
 I'm using the number 99 to disable any unused hour IF statements.

 I'm not currently using the Blink20 method.
 I used Blink20 to confirm that running pumpControl2-WithPumpsREV2 was
 actually running in a separate cog as I was developing this Object.
  
}}

con
   ON = 1
   OFF = 0
                                 
VAR
  long cog                      'This contains the ID of the cog this object is running in.
  long stack[10]                'I don't know what exactly is contained in the stack, but it must be important.
                                'Without these two variables, this object will not work.                  
  
PUB Start(p1hrs,p1mins):Success 'Start the PumpControl2-WithpumpsREV1 object in a new cog...Bring along
                                'Location of variables p1hrs,p1mins.

    Stop                        'If start is not successful, The cog is shut down.

    success := (cog := cognew(pump1(P1hrs, P1mins), @stack) +1)   'I'm not sure what exactly is going on here,
                                                                  'but it's a good thing.
                                                                  'Program is sent to the pump1 method.
 
PUB Stop 'Stops the Real Time Clock object, frees a cog.

    if cog
        cogstop(cog~ -1)

Pri SetupIO

   ' Pin 16 is the buzzer, make it an output and set it low.
  dira[16] := 1
  outa[16] := 0
  
  'Pin 20 is the center LED on the Quickstart board, Make it an output and set it low.
  dira[20] := 1
  outa[20] := 0
   'Pin23 is left end LED on the Quickstart board.  Make an output and set it low.
  Dira[23] :=1
  outa[23] :=0

   return
  
Pri Pump1(p1hrs, p1mins) | pumphours, pumpminutes  'PUB Start sends the program here

  SetupIO                                          '1st task is to set up the IO, so I go to the SetupIO method
  
repeat
  
  
'--------ON/OFF pump time-----Program #0---------------------------------
   if    99==Long[p1hrs] and 99==Long[p1mins]      'Turn Feed Pump on at ?

            Outa[23] :=ON

   If    99==Long[p1hrs] and 99==long[p1mins]      'Turn Feed Pump off at ?
     
            Outa[23] :=OFF

'--------ON/OFF pump time-----Program #1---------------------------------
   if    99==Long[p1hrs] and 99==Long[p1mins]      'Turn Feed Pump on at ?

            Outa[23] :=ON

   If    99==Long[p1hrs] and 99==long[p1mins]      'Turn Feed Pump off at ?
     
            Outa[23] :=OFF

'--------ON/OFF pump time-----Program #2---------------------------------
   if    2==Long[p1hrs] and 0==Long[p1mins]        'Turn Feed Pump On at 2:00am
   
            Outa[23] :=ON

   If    2==Long[p1hrs] and  15==long[p1mins]      'Turn Feed Pump off at 2:15am
  
            Outa[23] :=OFF

'--------ON/OFF pump time-----Program #3---------------------------------
   if    99==Long[p1hrs] and 99==Long[p1mins]      'Turn Feed Pump On at ?
 
            Outa[23] :=ON

   If    99==Long[p1hrs] and 99==long[p1mins]      'Turn Feed Pumps off at ?   
                                                   
            Outa[23] :=OFF
  
'--------ON/OFF pump time-----Program #4---------------------------------
   if    99==Long[p1hrs] and 99==Long[p1mins]      'Turn Feed Pump on at ?

            Outa[23] :=ON

   If    99==Long[p1hrs] and 99==long[p1mins]      'Turn Feed Pump off at ?
     
            Outa[23] :=OFF

  
'--------ON/OFF pump time-----Program #5---------------------------------
   if    99==Long[p1hrs] and 99==Long[p1mins]      'Turn Feed Pump on at ?

            Outa[23] :=ON

   If    99==Long[p1hrs] and 99==long[p1mins]      'Turn Feed Pump off at ?
     
            Outa[23] :=OFF

  
'--------ON/OFF pump time-----Program #6---------------------------------
   if    6==Long[p1hrs] and 0==Long[p1mins]        'Turn Feed Pump on at 6:00am

            Outa[23] :=ON

   If    6==Long[p1hrs] and 15==long[p1mins]       'Turn Feed Pump off at 6:15am
     
            Outa[23] :=OFF
 
  
'--------ON/OFF pump time-----Program #7---------------------------------
   if    7==Long[p1hrs] and 0==Long[p1mins]        'Turn Feed Pump on at 7:00am

            Outa[23] :=ON

   If    7==Long[p1hrs] and 15==long[p1mins]       'Turn Feed Pump off at 7:15am
     
            Outa[23] :=OFF

  
'--------ON/OFF pump time-----Program #8---------------------------------
   if    8==Long[p1hrs] and 0==Long[p1mins]        'Turn Feed Pump on at 8:00am

            Outa[23] :=ON

   If    8==Long[p1hrs] and 15==long[p1mins]       'Turn Feed Pump off at 8:15am
     
            Outa[23] :=OFF

  
'--------ON/OFF pump time-----Program #9---------------------------------
   if    9==Long[p1hrs] and 0==Long[p1mins]        'Turn Feed Pump on at 9:00am

            Outa[23] :=ON

   If    9==Long[p1hrs] and 15==long[p1mins]       'Turn Feed Pump off at 9:15am
     
            Outa[23] :=OFF

  
'--------ON/OFF pump time-----Program #10---------------------------------
   if    10==Long[p1hrs] and 0==Long[p1mins]       'Turn Feed Pump on at 10:00am

            Outa[23] :=ON

   If    2==Long[p1hrs] and 20==long[p1mins]       'Turn Feed Pump off at 10:20am
     
            Outa[23] :=OFF

  
'--------ON/OFF pump time-----Program #11---------------------------------
   if    11==Long[p1hrs] and 0==Long[p1mins]       'Turn Feed Pump on at 11:00am

            Outa[23] :=ON

   If    11==Long[p1hrs] and 15==long[p1mins]      'Turn Feed Pump off at 11:15am
     
            Outa[23] :=OFF

  
'--------ON/OFF pump time-----Program #12--NOON---------------------------
   if    12==Long[p1hrs] and 0==Long[p1mins]       'Turn Feed Pump on at 12:00Noon

            Outa[23] :=ON

   If    12==Long[p1hrs] and 20==long[p1mins]      'Turn Feed Pump off at 12:20pm
     
            Outa[23] :=OFF

  
'--------ON/OFF pump time-----Program #13---------------------------------
   if    13==Long[p1hrs] and 0==Long[p1mins]       'Turn Feed Pump on at 1:00pm

            Outa[23] :=ON

   If    13==Long[p1hrs] and 15==long[p1mins]      'Turn Feed Pump off at 1:15pm
     
            Outa[23] :=OFF

  
'--------ON/OFF pump time-----Program #14---------------------------------
   if    14==Long[p1hrs] and 0==Long[p1mins]       'Turn Feed Pump on at 2:00pm

            Outa[23] :=ON

   If    14==Long[p1hrs] and 15==long[p1mins]      'Turn Feed Pump off at 2:15pm
     
            Outa[23] :=OFF
  
'--------ON/OFF pump time-----Program #15---------------------------------
   if    15==Long[p1hrs] and 0==Long[p1mins]       'Turn Feed Pump on at 3:00pm

            Outa[23] :=ON

   If    15==Long[p1hrs] and 15==long[p1mins]      'Turn Feed Pump off at 3:15pm
     
            Outa[23] :=OFF
  
'--------ON/OFF pump time-----Program #16---------------------------------
   if    16==Long[p1hrs] and 0==Long[p1mins]       'Turn Feed Pump on at 4:00pm

            Outa[23] :=ON

   If    16==Long[p1hrs] and 20==long[p1mins]      'Turn Feed Pump off at 4:20pm
     
            Outa[23] :=OFF
  
'--------ON/OFF pump time-----Program #17---------------------------------
   if    17==Long[p1hrs] and 0==Long[p1mins]       'Turn Feed Pump on at 5:00pm

            Outa[23] :=ON

   If    17==Long[p1hrs] and 18==long[p1mins]      'Turn Feed Pump off at 5:18pm
     
            Outa[23] :=OFF

'--------ON/OFF pump time-----Program #18---------------------------------
   if    18==Long[p1hrs] and 0==Long[p1mins]       'Turn Feed Pump on at 6:00pm

            Outa[23] :=ON

   If    18==Long[p1hrs] and 15==long[p1mins]      'Turn Feed Pump off at 6:15pm
     
            Outa[23] :=OFF
  
'--------ON/OFF pump time-----Program #19---------------------------------
   if    19==Long[p1hrs] and 0==Long[p1mins]        'Turn Feed Pump on at 7:00pm

            Outa[23] :=ON

   If    19==Long[p1hrs] and 15==long[p1mins]      'Turn Feed Pump off at 7:15pm
     
            Outa[23] :=OFF
  
'--------ON/OFF pump time-----Program #20---------------------------------
   if    20==Long[p1hrs] and 0==Long[p1mins]       'Turn Feed Pump on at 8:00pm

            Outa[23] :=ON

   If    20==Long[p1hrs] and 15==long[p1mins]       'Turn Feed Pump off at 8:15pm
     
            Outa[23] :=OFF
  
'--------ON/OFF pump time-----Program #21---------------------------------
   if    21==Long[p1hrs] and 0==Long[p1mins]        'Turn Feed Pump on at 9:00pm

            Outa[23] :=ON

   If    21==Long[p1hrs] and 30==long[p1mins]       'Turn Feed Pump off at 9:30pm
     
            Outa[23] :=OFF
  
'--------ON/OFF pump time-----Program #22---------------------------------
   if    99==Long[p1hrs] and 99==Long[p1mins]       'Turn Feed Pump on at ?

            Outa[23] :=ON

   If    99==Long[p1hrs] and 99==long[p1mins]       'Turn Feed Pump off at ?
     
            Outa[23] :=OFF
  
'--------ON/OFF pump time-----Program #23---------------------------------
   if    23==Long[p1hrs] and 0==Long[p1mins]        'Turn MakeupPump on at 11:00pm

            Outa[20] :=ON  'MAKEUP-PUMP

   If    0==Long[p1hrs] and 0==long[p1mins]         'Turn MakeupPump off at Midnight
     
            Outa[20] :=OFF  'MAKEUP-PUMP


pri  Blink20


  outa[16]:=1                                       'Turn on the buzzer
  waitcnt(clkfreq*1+cnt)
  outa[16]:=0                                       'Turn off the buzzer
  outa[23]:=0                                       'Turn off the LeftMost quickstart LED
  outa[20]:=0                                       'Turn off the center quickstart LED
  return                                            'Go back to the repeat loop in pump1 method.
                                   
 